package cn.rongcloud.beauty.wrapper.flutter;

import androidx.annotation.NonNull;

import java.util.HashMap;

import cn.rongcloud.beauty.wrapper.config.RCBeautyIWFilter;
import cn.rongcloud.beauty.wrapper.config.RCBeautyIWOptions;

/**
 * Created by wangw on 2021/8/5.
 */
public class ArgumentAdapter {

	public static RCBeautyIWOptions toRCBeautyIWOptions(HashMap<String, Object> option) {
    	if (option == null) {
    		return null;
		}
		RCBeautyIWOptions beautyOption = new RCBeautyIWOptions();
    	if (option.containsKey("whitenessLevel")) {
			beautyOption.setWhitenessLevel((Integer) option.get("whitenessLevel"));
		}
		if (option.containsKey("smoothLevel")) {
			beautyOption.setSmoothLevel((Integer) option.get("smoothLevel"));
		}
		if (option.containsKey("ruddyLevel")) {
			beautyOption.setRuddyLevel((Integer) option.get("ruddyLevel"));
		}
		if (option.containsKey("brightLevel")) {
			beautyOption.setBrightLevel((Integer) option.get("brightLevel"));
		}
    	return beautyOption;
	}

	public static RCBeautyIWFilter toRCBeautyIWFilter(@NonNull int filter) {
		return RCBeautyIWFilter.values()[filter];
	}

	public static HashMap<String, Object> fromRCBeautyIWOptions(RCBeautyIWOptions option) {
		HashMap<String, Object> map = new HashMap<>();
		if (option == null) {
			return map;
		}
		map.put("whitenessLevel", option.getWhitenessLevel());
		map.put("smoothLevel", option.getSmoothLevel());
		map.put("ruddyLevel", option.getRuddyLevel());
		map.put("brightLevel", option.getBrightLevel());
		return map;
	}
}
