#import "RCBeautyWrapperPlugin.h"
#import <RongFaceBeautifierWrapper/RongFaceBeautifierWrapper.h>
#import "ArgumentAdapter.h"
#import <RongIMLibCore/RongIMLibCore.h>

static NSString * const VER = @"5.3.1";

@implementation RCBeautyWrapperPlugin

+ (void)load {
    [RCUtilities setModuleName:@"beautyflutter" version:[self getVersion]];
}

+ (NSString *) getVersion {
    return VER;
}

+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"cn.rongcloud.beauty.flutter/engine"
            binaryMessenger:[registrar messenger]];
  RCBeautyWrapperPlugin* instance = [[RCBeautyWrapperPlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
  if ([@"setBeautyOptions" isEqualToString:call.method]) {
      [self setBeautyOptions:call result:result];
  } else if ([@"getCurrentBeautyOptions" isEqualToString:call.method]) {
      [self getCurrentBeautyOptions:result];
  } else if ([@"setBeautyFilter" isEqualToString:call.method]) {
      [self setBeautyFilter:call result:result];
  } else if ([@"getCurrentBeautyFilter" isEqualToString:call.method]) {
      [self getCurrentBeautyFilter:result];
  } else if ([@"resetBeauty" isEqualToString:call.method]) {
      [self resetBeauty:result];
  } else {
    result(FlutterMethodNotImplemented);
  }
}

- (void)setBeautyOptions:(FlutterMethodCall *)call result:(FlutterResult)result {
    NSDictionary *arguments = (NSDictionary *)call.arguments;
    BOOL enable = arguments[@"enable"];
    NSDictionary *options = arguments[@"options"];
    BOOL res = [[RCBeautyIWEngine sharedInstance] setBeautyOptions:enable options:toRCBeautyIWOptions(options)];
    result(@(res));
  }

- (void)getCurrentBeautyOptions:(FlutterResult)result {
    RCBeautyIWOptions *options = [[RCBeautyIWEngine sharedInstance] getCurrentBeautyOptions];
    result(fromRCBeautyIWOptions(options));
  }

- (void)setBeautyFilter:(FlutterMethodCall *)call result:(FlutterResult)result {
    NSInteger filter = [call.arguments integerValue];
    BOOL res = [[RCBeautyIWEngine sharedInstance] setBeautyFilter:filter];
    result(@(res));
  }

- (void)getCurrentBeautyFilter:(FlutterResult)result {
    RCBeautyIWFilter filter = [[RCBeautyIWEngine sharedInstance] getCurrentBeautyFilter];
    result(@(filter));
  }

- (void)resetBeauty:(FlutterResult)result {
    [[RCBeautyIWEngine sharedInstance] resetBeauty];
    result(@(0));
  }

@end
