//
//  RCBeautyIWEngine.h
//  RongFaceBeautifierWrapper
//
//  Created by RongCloud on 4/14/22.
//

#import <Foundation/Foundation.h>
#import "RCBeautyIWDefines.h"

@class RCBeautyIWOptions;


NS_ASSUME_NONNULL_BEGIN

@interface RCBeautyIWEngine : NSObject

+ (RCBeautyIWEngine *)sharedInstance;

/*!
 设置美颜参数
 
 @param enable YES/NO 是否开启美颜 默认关闭
 @param options 美颜配置参数
 */
- (BOOL)setBeautyOptions:(BOOL)enable options:(nullable RCBeautyIWOptions *)options;

/*!
 获取当前美颜参数

 @return RCRTCBeautyIWOptions 当前美颜参数对象
 */
- (RCBeautyIWOptions *)getCurrentBeautyOptions;

/*!
 配置视频滤镜
 
 @param filter 滤镜类型
 */
- (BOOL)setBeautyFilter: (RCBeautyIWFilter)filter;

/*!
 获取当前滤镜参数

 @return RCRTCBeautyIWFilter 当前滤镜类型
 */
- (RCBeautyIWFilter)getCurrentBeautyFilter;

/*!
 重置美颜的滤镜参数
 因为 RCRTCBeautyIWEngine 类是单例对象，所以会保留开发者设置的美颜参数或滤镜类型，
 在需要重置美颜的时候（例如重复进入房间时）需要调用 reset 方法重置所有美颜参数和滤镜。
 */
- (void)resetBeauty;

@end

NS_ASSUME_NONNULL_END
