#!bin/bash

help="updateVersion.sh -v <version> -i <ios> -a <android> \nNotic: -v relase version -i ios version -a android version"

while getopts ":v:i:a:" opt
do
    case $opt in
        v)
        version=$OPTARG
        ;;
        i)
        ios_version=$OPTARG
        ;;
        a)
        android_version=$OPTARG
        ;;
        ?)
        echo "$help"
        exit 1;;
    esac
done


if [ -z "$version" ]; then
  echo "$help"
  exit 1
fi

if [ -z "$ios_version" ]; then
  echo "$help"
  exit 1
fi

if [ -z "$android_version" ]; then
  echo "$help"
  exit 1
fi

cd $(dirname "$0")/.. && pwd;

# 修改 pubspec 版本号
pubspec_path=./pubspec.yaml
awk "{ gsub(/^version.*/, \"version: ${version}\"); print;}" $pubspec_path > .tmp && mv .tmp $pubspec_path

# 修改 iOS 依赖版本
config_path=./version.config
awk "{ gsub(/ios_sdk_version=.*/, \"ios_sdk_version=${ios_version}\"); print;}" $config_path > .tmp && mv .tmp $config_path
awk "{ gsub(/android_sdk_version=.*/, \"android_sdk_version=${ios_version}\"); print;}" $config_path > .tmp && mv .tmp $config_path



